/*
		des clefs (hors du mur)
		=======================

	Si vous dsirez en savoir (un peu) plus sur ce fichier,
	il faut vous referer au grand Ternet. Qui contient, on le
	sait, la rponse ultime  toutes les questions.
*/

/* --------------------------------------------------------------------- */
#local CL0_DA = 2.15;		// diametre anneau
#local CL0_EA = 0.20;		// epaisseur anneau
#local CL0_MD = 0.098;		// mini diametre (rayures)
#local CL0_DT = 0.62;		// diametre tige

#declare Clef_0_anneau = object
{
#declare MR = CL0_MD/2;
#declare EA2 = CL0_EA-MR;
difference
	{
	merge
		{
		cylinder { <0, -CL0_EA, 0>, <0, CL0_EA, 0>, CL0_DA-MR } 
		cylinder { <0, -EA2, 0>, <0, EA2, 0>, CL0_DA } 

		torus { CL0_DA-MR, MR translate y*(CL0_EA-(MR)) }
		torus { CL0_DA-MR, MR translate y*-(CL0_EA-(MR)) }
		}
		
	cylinder { <0, -(CL0_EA+.3), 0>, <0, CL0_EA+.3, 0>, 1.25 }  // le trou

	/* les 4 rayures */
	torus { 1.8, MR translate y*CL0_EA }
	torus { 1.8, MR translate y*-CL0_EA }
	torus { 1.5, MR translate y*CL0_EA }
	torus { 1.5, MR translate y*-CL0_EA }
	}
}

#declare Clef_0 = object
{
merge
	{
	cylinder { <-4, 0, 0>, <6, 0, 0>, CL0_DT/2 }

	/* le bout de la tige */
	sphere	 { < 6, 0, 0>, CL0_DT/2 }

	/* la jonction avec l'anneau */
	sphere	 { <-4, 0, 0>, (CL0_DT/2)*1.33  }

	cylinder { < 4.5, 0, 0>, < 5.5, 0, 0>, (CL0_DT/2)+MR }
	torus { CL0_DT/2, CL0_MD/2 rotate z*90 translate x*4.5 }
	torus { CL0_DT/2, CL0_MD/2 rotate z*90 translate x*5.5 }

	box	 { < 4.6, -0.13, 0>, <5.4, 0.13, -1.9> }

	/* le renflement pres de l'anneau */
	cylinder { <-3.5, 0, 0>, <-2.8, 0, 0>, (CL0_DT/2)+MR }
	torus { CL0_DT/2, CL0_MD/2 rotate z*90 translate x*-3.5 }
	torus { CL0_DT/2, CL0_MD/2 rotate z*90 translate x*-2.8 }

	object { Clef_0_anneau translate x*-6.1 }
	}

}

/* --------------------------------------------------------------------- */
/*
 *	update 20 Jan 2002 for the ExPOVsition
 */

#local CL1_DA = 1.9;		// diametre anneau
#local CL1_DT = 0.5;		// diametre trou
#local CL1_EA = 0.13;		// epaisseur anneau
#local CL1_EB = 0.15;		// epaisseur barre
#local CL1_DB = CL1_EB/1.02;	// dimension bulle

#declare Clef_1_creux_label = object
{
box { <-0.333, CL1_EA/2, -1>, <0.333, 10, 1> }
rotate 5*y
}

#declare Clef_1_anneau = object
{
merge
	{
	difference
		{
		cylinder { <-6, -CL1_EA, 0>, <-6, CL1_EA, 0>, CL1_DA }
		cylinder { <-7, -.42, 0>, <-7, .42, 0>, CL1_DT }
		object { Clef_1_creux_label translate x*-5.7 }
		}
	torus { CL1_DA, CL1_EA translate -x*6 }
	torus { CL1_DT, CL1_EA translate -x*7 }
	}
}

#declare Clef_1_corps = object
{
difference
	{
	merge
		{
		box { <-3.1, -CL1_EB, -0.5>, <4.5, CL1_EB, 0.5> }
		cylinder { <-3.1, -CL1_EB, 0>, <-3.1, CL1_EB, 0>, 0.5 }
		cylinder { < 4.5, -CL1_EB, 0>, < 4.5, CL1_EB, 0>, 0.5 }
		}
	merge
		{
		/* la rayure */
		cylinder { <-2.5, CL1_EB, 0>, <4.5, CL1_EB, 0>, CL1_EB/1.4 }
		sphere { <-2.5, CL1_EB, 0>, CL1_EB/1.4 }
		sphere { < 4.5, CL1_EB, 0>, CL1_EB/1.4 }

		/* les petits trous */
		sphere { <-2.0, -CL1_EB,    0>, CL1_DB }
		sphere { <-1.5, -CL1_EB,  0.2>, CL1_DB }
		sphere { <-1.0, -CL1_EB,  0.2>, CL1_DB }
		sphere { <-0.5, -CL1_EB, -0.2>, CL1_DB }
		sphere { < 0.0, -CL1_EB,    0>, CL1_DB }
		sphere { < 0.5, -CL1_EB,  0.2>, CL1_DB }
		sphere { < 1.0, -CL1_EB,    0>, CL1_DB }
		sphere { < 1.5, -CL1_EB, -0.2>, CL1_DB }
		sphere { < 2.0, -CL1_EB,  0.2>, CL1_DB }
		sphere { < 2.5, -CL1_EB,    0>, CL1_DB }
		sphere { < 3.0, -CL1_EB,    0>, CL1_DB }
		sphere { < 3.5, -CL1_EB,  0.0>, CL1_DB }
		sphere { < 4.0, -CL1_EB, -0.2>, CL1_DB }
		sphere { < 4.5, -CL1_EB,  0.2>, CL1_DB }

		/* et sur l'autre face aussi... FIXME */
		sphere { < 1.5,  CL1_EB, -0.3>, CL1_DB }
		sphere { < 2.0,  CL1_EB,  0.3>, CL1_DB }
		sphere { < 2.5,  CL1_EB, -0.3>, CL1_DB }
		sphere { < 3.0,  CL1_EB,  0.2>, CL1_DB }
		sphere { < 4.3,  CL1_EB, -0.3>, CL1_DB }
		sphere { <-2.0,  CL1_EB,  0.3>, CL1_DB }
		}
	}
}

#declare Clef_1 = object
{
merge
	{
	object	{ Clef_1_anneau }
	sphere	 { <0, 0, 0>, 0.32 scale <1.4, 1, 1> translate -x*4.4 }
	cylinder { <-4.5, 0, 0>, <-3.3, 0, 0>, .3 }
	sphere	 { <0, 0, 0>, 0.32 scale <1.4, 1, 1> translate -x*3.3 }
	object 	{ Clef_1_corps }
	}
}

/* --------------------------------------------------------------------- */
/*
 *	il n'y a pas de clef 2 ? bah non, c'est pas normal !-)
 *
 *	- 8 septembre 2006, je m'y attaque, je vais faire du crade.
 */

#declare Clef_2_base = object
{
merge	{
	/* la poignee de la clef */
	difference {
		box { <-5, -0.3, -1.8>, <-6, 0.3, 1.8> }
		cylinder { <-5.5, -0.4, 1.3>, <-5.5, 0.4, 1.3>, 0.3 }
		}
	cylinder { <-5, 0, 0>, <-6, 0, 0>, 0.3
				scale <1, 1, 0.5> translate -z*1.8 }
	cylinder { <-5, 0,  0>, <-6, 0,  0>, 0.3 
				scale <1, 1, 0.5> translate  z*1.8 }

	/* la tige de la clef */
	cylinder { <-5.1, 0, 0>, <4.8, 0, 0>, .22 }
	
	/* XXX */
	box { <4, -0.5, -0.08>, <3, 0.5, 0.08> }
	box { <1, -0.5, -0.08>, <0, 0.5, 0.08> }
	box { <3, -0.5, -0.08>, <1.5, 0.5, 0.08> rotate 45*x }
	box { <4.5, -0.5, -0.08>, <3.5, 0.5, 0.08> rotate 90*x }

	sphere { <4.8, 0, 0>, .22 }
	}
}

/* les trucs-machins de la clef */

#declare Clef_2 = object
{
object { Clef_2_base }
}
/* --------------------------------------------------------------------- */
/*
 *	une vieille clef traditionnelle, dessine  la demande de
 *	mon fils Lon, collectionneur de clefs.
 *
 *	-->	oriente sur l'axe des X
 */

#declare CL3_D = 0.28;

#declare Clef_3_anneau = object
{
merge
	{
	intersection
		{
		torus { 2 CL3_D translate z*-1.5 }
		box { <-10, -10, -10>, <10, 10, 0> }
		}
	intersection
		{
		torus { 2 CL3_D translate z*1.5 }
		box { <-10, -10, 0>, <10, 10, 10> }
		}
	}
scale <1, 1, 0.55>
}

#declare Clef_3_tige = object
{
merge
	{
	cylinder { <-3, 0, 0>, <6.5, 0, 0>, CL3_D }
	cone { <-3, 0, 0>, CL3_D, <-3.8, 0, 0>, CL3_D/5 }
	sphere { <6.5, 0, 0>, CL3_D }
	}
}

#declare Clef_3_chateau = object
{
difference
	{
	box { <-1, -(CL3_D/1.69), 0>, <1, CL3_D/1.69, 1.8> }
	box { <-0.5, -CL3_D, 1.1>, <-0.8, CL3_D, 2.1> }
	box { <0.2, -CL3_D, 1.2>, <0.7, CL3_D, 2.1> }
	cylinder { <-1.2, -0.20, 0.6>, <1.2, -0.20, 0.6>, 0.17 }
	}
}

#declare Clef_3 = object
{
merge
	{
	object { Clef_3_anneau translate x*-4.9 }
	object { Clef_3_tige }
	object { Clef_3_chateau translate x*5 }
	}
}

/* --------------------------------------------------------------------- */
/*
 *	CLEF NUMERO QUATRE - new 11 nov 2006, av St Exupery
 */
#declare Clef_4 = object
{
union	{
	difference {
		box { <-0.7, -0.03, 0>, <0.7, 0.03, 3> }
		cylinder { <0.3, -1, 1>, <0.3, 1, 1>, 0.14 }
		cylinder { <0.3, -1, 2>, <0.3, 1, 2>, 0.14 }
		cylinder { <-0.3, -1, 2>, <-0.3, 1, 2>, 0.14 }
		}
	torus { 1.0, 0.15 translate -0.9*z }
	}
}
/* --------------------------------------------------------------------- */

