/*
 *		LABTOOLS.INC
 *		============
 *	new - 11 aout 2006 - avenuse Saint Exupery.
 *	une collection de machins pour un laboratoire virtuel.
 *
 *	XXX attention, les noms de ces objets ne sont probablement
 *	    pas definitifs. Je ne sais pas vraiment comment gerer
 *	    les "namespaces" avec POVray :(
 *
 */
/* ------------------------------------------------------------------ */
#include  "woods.inc"

/* ================================================================== */
#declare Labtools_Bakelite = texture
{
pigment { rgb <0.48, 0.45, 0.36> }
normal { agate 0.120 scale 2.20 }
finish  { phong 0.6 ambient 0.3 }
}
#declare Labtools_Metal = texture
{
pigment { color rgb <0.799, 0.770, 0.760> }
finish  { phong 0.1 ambient 0.1 reflection 0.4 metallic 0.8 }
}
#declare Labtools_Rouge = texture
{
pigment { color rgb <0.84, 0.12, 0.12> }
finish { phong 0.98 }
}
#declare Labtools_Vert = texture
{
pigment { color Green }
finish { phong 0.88 }
}
/* ================================================================== */
/*
 *	il nous faut quelques objetx de base, que nous pourrons 
 *	utiliser un peu partout, pour reussir une cohesion sociale
 *	au sein de tous les outils du laboratoire. Grace a la 
 *	puissance du povisme, nous ne serons pas oblige d'en
 *	passer par la case "chanteuse polygame" pour arriver a ce
 *	que nous voulons montrer au monde.
 */

#declare Labtools_une_borne = object
{
union	{
	cylinder { <0, 0, 0>, <0, 1.33, 0>, 0.71 }
	sphere { <0, 1.33, 0>, 0.71 }
	}
}

#declare Labtools_Borne_Rouge = object
{
object {  Labtools_une_borne }
texture { Labtools_Rouge }
}
#declare Labtools_Borne_Verte = object
{
object {  Labtools_une_borne }
texture { Labtools_Vert }
}
/* ================================================================== */
/* new 31 may 2007
 *    A GREAT STATICATOR
 */
#declare Staticator_base = object
{
union	{
	box { <-20.00, 0, -12.00>, <20.00, 1.85,  12.00>
		texture { T_Wood5 rotate <3, 95, -1> scale 12 }}
	box { <-19.00, 1, -11.00>, <19.00, 3.10,  11.00>
		texture { T_Wood5 rotate <-3, 89, -4> scale 12 }}
	}
}

/* ------------------------------------------------------------------ */
#declare Staticator_base_col = object
{
cylinder { <0, 0, 0>, <0, 1, 0>, 4 }
pigment { color rgb <0.12, 0.36, 0.12> }
}
#declare Staticator_fut_col = object
{
merge	{
	cylinder { <0, 0, 0>, <0, 16, 0>, 1.40 }
	sphere { <0, 0, 0>, 1.40 scale <1, 0.66, 1> translate y*16 }
	}
texture { Labtools_Bakelite }
}
#declare Staticator_colonne = object
{
union	{
	object { Staticator_base_col }
	object { Staticator_fut_col }
	}
translate y*3.10
}
/* ------------------------------------------------------------------ */
/* new element, 3 sept 2007 */
#declare Staticator_etoile_a = object
{
difference {
	cylinder { <0, 0, 0>, <0, 0, 10>, 0.7 }
	cylinder { <0, 0.84, 0>, <0, 0.84, 10>, 0.4 }
	}
}
#declare Staticator_etoile_b = object
{
sphere { <0, 0, 0>, 1.33 }
}
#declare Staticator_etoile_bras = object
{
union	{
	object { Staticator_etoile_a }
	object { Staticator_etoile_b translate 10*z }
	}
}
#declare Staticator_etoile = object
{
#declare foo = 0;
union	{
	cylinder { <0, -1.00, 0>, <0, 1.00, 0>, 2.00 }
#while (foo < 360)
	object { Staticator_etoile_bras rotate foo*y }
	#declare foo = foo + 60.001;
#end
	}

texture { Labtools_Metal }

rotate (clock*0.3333)*y
}
/* ------------------------------------------------------------------ */
#declare Staticator = object
{
union	{
	object { Staticator_base }
	object { Staticator_colonne }
	object { Staticator_etoile translate y*17 }
	object { Labtools_Borne_Rouge translate <-17, 3.10, -6> }
	object { Labtools_Borne_Verte translate <-17, 3.10,  6> }
	}
}

/* ================================================================== */
#declare Potard_bouton = object
{
union	{
	cylinder { <0, 0.4, 0>, <0, 1.6, 0>, 3.4 }

	cylinder { <0, 1.5, 0>, <0, 2, 0>, 4 }
	torus { 4, 0.125 scale <1, 2, 1> translate 1.75*y }
	}
texture {
	pigment { color rgb <0.3, 0.4, 0.8> }
	finish { phong 0.7 ambient 0.27 }
	}
}
#declare Potard_Box_les_boutons = object
{
union {
	object { Potard_bouton  rotate y*17   translate <0, 9, -22> }
	object { Potard_bouton  rotate y*37   translate <0, 9, -11> }
	object { Potard_bouton  rotate y*44   translate <0, 9, 0> }
	object { Potard_bouton  rotate y*98   translate <0, 9, 11> }
	object { Potard_bouton  rotate y*11   translate <0, 9, 22> }
	}
pigment { color  Green }
}
#declare Potard_Box_body_a = object
{
box { <-6, 0, -28>, <6, 8, 28> }
texture { Labtools_Bakelite }
}
#declare Potard_Box_body_b = object
{
box { <-6.5, 8, -28.5>, <6.5, 9, 28.5> }
pigment { color  Gray50 }
}

#declare Potard_Box = object
{
union	{
	object { Potard_Box_body_a }
	object { Potard_Box_body_b }
	object { Potard_Box_les_boutons }
	}
}
/* ------------------------------------------------------------------ */
/*
 *	Une sorte d'espece de gros machin a cadran - new 17 sept 2006
 */
#declare Mesureur_body = object
{
union	{
	box { <-20, 0, -20>, <20, 8, 20> }
	box { <-22, 0, -22>, <22, 1, 22> }
	box { <-22, 7, -22>, <22, 9, 22> }
	}
texture { Labtools_Bakelite }
}

#declare Mesureur_circle = object
{
union	{
	difference {
		cylinder { <0, 8.9, 0>, <0, 11, 0>, 19 }
		cylinder { <0, 8.8, 0>, <0, 13, 0>, 18.5 }
		}
	torus { 18.75, 0.24 translate 11*y }
	}
texture { Labtools_Bakelite }
}

#declare Mesureur_cadran = object
{
difference {
	cylinder { <0, 10.2, 0>, <0, 10.8, 0>, 18.01 }
	cylinder { <0, 10.1, 0>, <0, 10.9, 0>, 3.12 }
	}
texture	{
	pigment { color Gray80  }
	finish { ambient 0.55 reflection 0.42 }
	}
}
#declare Mesureur_graduations = object
{
union	{
#declare foo = 30;
#while (foo < 315)
	#declare dx = cos(radians(foo)) * 15.00;
	#declare dz = sin(radians(foo)) * 15.00;
	sphere { <0, 0, 0>, 2.45-(foo*0.0012) scale <1, 0.42, 1>
			    translate <dx, 10.4, dz> }
	#declare foo = foo + 20;
#end
	}
texture	{
	pigment { color NavyBlue }
	finish { phong 0.80 metallic 0.80 }
	}
}

#declare Mesureur_aiguille = object
{
union	{
	box { <-17, 0.333, -0.5>, <3, 0.666, 0.5> }
	box { <-1, 0.33, -1>, <1, 0.33, 1> rotate y*45 translate x*3 }
	cylinder { <0, -2, 0>, <0, 1.2, 0>, 1.14 }
	sphere { <0, 0, 0>, 1.05 scale <1, 0.333, 1> translate 1.25*y }
	}
texture {  Labtools_Metal }
translate y*10.5 
}

/* ------------------------------------------------------------------ */
#declare Mesureur_knob_a = object
{
/* new Jan, 13, 2012 */
difference {
	cylinder { <0, 0, 0>, <0, 2, 0>, 2.1 }
	cylinder { <0, 1, 0>, <0, 3, 0>, 2.0 }
	}
texture { Labtools_Metal }
}

#declare Mesureur_knob_b = object
{
/* new Jan, 13, 2012 */
merge	{
	cylinder { <0, 1, 0>, <0, 2, 0> 1.1 }
	sphere { <0, 0, 0>, 1.1 scale <1, 0.455, 0> translate 2*y }
	}
texture { Labtools_Rouge }
}

#declare Mesureur_knob = object
{
union	{
	object { Mesureur_knob_a }
	object { Mesureur_knob_b }
	}
translate <17, 10, -16>
}
/* new Jan, 13, 2012 */

/* ------------------------------------------------------------------ */
#declare Mesureur = object
{
union	{
	object { Mesureur_body }
	object { Mesureur_circle }
	object { Mesureur_cadran }
	object { Mesureur_graduations }
	object { Mesureur_aiguille }
	object { Mesureur_knob }
	}
}
/* ================================================================== */
/*   une balance de precision - new 30 septembre 2006 		*/
 
#declare Support_Balance_base = object
{
union	{
	box { <-31, 0, -12>, <31, 1.85, 12> }
	box { <-30, 1, -6>, <30, 3.1, 5> }
	}
/*
texture	{
	pigment { color Yellow }
	finish { phong 0.01 }
	}
*/
texture { T_Wood2 rotate <3, 92.5, -1> scale 15 }
}

#declare Support_Balance_haut_col = object
{
difference {
	box { <-2.5, 0, -2>, <2.5, 5, 2> }
	box { <-4, 0.1, -1.9>, <4, 6, 1.9> }
	}
}
#declare Support_Balance_colonne = object
{
union	{
	cylinder { <0, 0, 0>, <0, 42, 0>, 0.7 }
	cylinder { <0, 0, 0>, <0, 4.2, 0>, 1.7 }
	object { Support_Balance_haut_col translate y*42 }
	}
texture {
	pigment { color Cyan }
	finish { phong 0.5 }
	}
}

//		-------------------------------------
/*
 *	dans un premier temps, on va laisser le bras oscillant
 *	de la balance parfaitement horizontal.
 */
#declare Bras_Balancier = object
{
box { <-31, -0.7, -0.5>, <31, 0.7, 0.5> }
texture {
	pigment { color Magenta }
	finish { phong 0.95 }
	}
}

#declare Plateau_Balance = object
{
intersection {
	difference {
		sphere { <0, 0, 0>, 30 }
		sphere { <0, 0, 0>, 29.8 }
		}
	cylinder { <0, -50, 0>, <0, -10, 0>, 12 }
	}
pigment { color <0.55, 0.50, 0.50> }
translate y*-4.5
}

#declare Fils_Balance = object
{
merge	{
	cylinder { <-12, -32, 0>, <0, 0, 0>, 0.2 }
	cylinder { < 12, -32, 0>, <0, 0, 0>, 0.2 }
	cylinder { < 0, -32, -12>, <0, 0, 0>, 0.2 }
	cylinder { < 0, -32,  12>, <0, 0, 0>, 0.2 }
	}
pigment { color Brown }
}

#declare Balancier = object
{
union	{
	object { Bras_Balancier }
	object { Plateau_Balance translate -x*30 }
	object { Fils_Balance    translate -x*30 }
	object { Plateau_Balance translate  x*30 }
	object { Fils_Balance    translate  x*30 }
	}
translate y*(42+3)
}

//		-------------------------------------

#declare Balance_de_Precision = object
{
union	{
	object { Support_Balance_base }
	object { Support_Balance_colonne }
	object { Balancier }
	}
}
/* ================================================================== */
#declare Support_Pendule_base = object
{
union	{
	box { <-32, 0, -9>, <32, 2.22, 9>
		texture { T_Wood2 scale 12 rotate 80*y } }
	box { <-30.50, 1, -8>, <30.50, 3.1, 8>
		texture { T_Wood2 scale 14 rotate 101*y } }
	}
}
#declare Support_Pendule_cadre = object
{
union	{
	cylinder { <-26, 3.0, 0>, <-26, 3.3, 0>, 3.8 }
	cylinder { < 26, 3.0, 0>, < 26, 3.3, 0>, 3.8 }

	cylinder { <-26, 1, 0>, <-26, 39, 0>, 0.5 }
	cylinder { < 26, 1, 0>, < 26, 39, 0>, 0.5 }

	cylinder { < 30, 39, 0>, <-30, 39, 0>, 0.5 }
	sphere { <-30, 39, 0>, 0.6 }
	sphere { < 30, 39, 0>, 0.6 }
	}
texture {
	pigment { color rgb <0.1, 0.55, 0.7> }
	finish { phong 0.5 }
	}
}

/* nouveau 23 janvier 2010 */
#include "visserie.inc"
#declare Support_Pendule_4_vis = object
{
#local evis = 1.8;
union	{
	object { Frm_Tete_Cruciforme_0 translate <-evis, 0, -evis> }
	object { Frm_Tete_Cruciforme_0 translate < evis, 0, -evis> }
	object { Frm_Tete_Cruciforme_0 translate <-evis, 0,  evis> }
	object { Frm_Tete_Cruciforme_0 translate < evis, 0,  evis> }
	}
texture {  Labtools_Metal } 
translate y*3.35 
}

#declare Support_Pendule = object
{
union {
	object { Support_Pendule_base }
	object { Support_Pendule_cadre }
	object { Support_Pendule_4_vis translate -26*x }
	object { Support_Pendule_4_vis translate  26*x }
	}
}
#declare Barre_Pendule = object
{
union	{
	cylinder { <-1, 0, 0>, <1, 0, 0>, 0.74 }
	cylinder { <0, 0, 0>, <0, -28, 0>, 0.35 }
	sphere   { <0, 0, 0>, 1.5 scale <1.2, 1, 1.2> translate -28*y}
	}
}
#declare Les_Barres = object
{
union	{
#declare foo = 0;
#while (foo < 12)
	#declare dx = (foo * 4.1) - 21.5;
        #declare phy = ((clock/5) + foo);
	#declare rot = sin(phy/2) * 20;
	object { Barre_Pendule rotate x*rot translate <dx, 39, 0> }
	#declare foo = foo + 1;
#end
	}
texture {
	pigment { color rgb <0.3, 0.4, 0.8> }
	finish { phong 0.7 }
	}
}
#declare Systeme_Pendules = object
{
union	{
	object { Support_Pendule }
	object { Les_Barres }
	}
}
/* ------------------------------------------------------------------ */

/* ------------------------------------------------------------------ */

/* ------------------------------------------------------------------ */

#declare LTO_Base_0 = object
{
union	{
	box { <-10, 0, -10>, <10, 4, 10> }
	box { <-8, 3, -8>, <8, 5, 8> }
	}
}
/* ------------------------------------------------------------------ */
