/*
	plomberie.inc - quelques robinets...
*/

#declare PLOMB_DIAM = 10;
#declare VANNE_L = 61;

/* ==---------------------------------------------------------== */

#declare Robinet_0_Volant = object
{
union	{
	torus { 13, 1.2 translate y*1.7 }
	cylinder { <0, -2, 0>, <0, 1.3, 0>, 2 }
	sphere { <0, 1.2, 0>, 2 }
	#declare foo=0;
	#while (foo<360)
		#declare px=sin(radians(foo));
		#declare pz=cos(radians(foo));
		cylinder {
			<0, 0, 0>,
			<px*13, 1.7, pz*13>,
			0.86
			}
		#declare foo=foo+60;
	#end
	#declare foo=0;
	#while (foo<360)
		#declare px=sin(radians(foo));
		#declare pz=cos(radians(foo));
		sphere {
			<0, 0, 0>, 1.3
			scale <0.5, 1.5, 0.8>
			rotate y*(foo)
			translate <px*13, 1.65, pz*13>
			}
		#declare foo=foo+30;
	#end
	}
texture
	{
	pigment { color Red }
	finish { specular 0.59 }
	}
translate y*PLOMB_DIAM*1.85
}

#declare Robinet_0_Corps = object
{
union
	{
	difference
		{
		cylinder { <-VANNE_L/2, 0, 0>, <VANNE_L/2, 0, 0>, PLOMB_DIAM }
		cylinder { <-VANNE_L, 0, 0>, <VANNE_L, 0, 0>, PLOMB_DIAM*0.9 }
		}
	difference
		{
		cylinder { <-(VANNE_L/2)+1, 0, 0>, <-(VANNE_L/2)+4, 0, 0>,
							PLOMB_DIAM*1.05 }
		cylinder { <-(VANNE_L/2), 0, 0>, <-(VANNE_L/2)+5, 0, 0>,
							PLOMB_DIAM*.9 }
		}
	sphere { <0, 0, 0>, PLOMB_DIAM*1.42 }

	torus { PLOMB_DIAM*1.39, 0.8 scale <1, 1.45, 1> }

	cylinder { <0, 0, 0>, <0, PLOMB_DIAM*1.77>, PLOMB_DIAM/2 }
	}
texture
	{
	pigment { color <0.8, 0.8, 0.82> }
	finish { phong_size 5.55 metallic 0.75 }
	}
}

#declare Robinet_0 = object
{
union
	{
	object { Robinet_0_Volant }
	object { Robinet_0_Corps }
	}
}
/* ============================================================= */
#declare Robinet_1_corps = object
{
difference {
	cylinder { <-VANNE_L/2, 0, 0>, <VANNE_L/2, 0, 0>, PLOMB_DIAM }
	cylinder { <-VANNE_L, 0, 0>, <VANNE_L, 0, 0>, PLOMB_DIAM*0.90 }
	}
texture {
	pigment { color <0.9, 0.9, 0.92> }
	finish { metallic 0.75 }
	}
}

#declare Robinet_1_une_plaque = object
{
union	{
	box { <-1, -14, -14>, <1, 14,  14> }
	box { <-1.2, -12, -12>, <-0.999, 12,  12> }
	}
}
#declare Robinet_1_les_plaques = object
{
union	{
	object { Robinet_1_une_plaque translate -7*x }
	object { Robinet_1_une_plaque rotate 180*y translate  7*x }
	}
texture {
	pigment { color <0.3, 0.6, 0.9> }
	finish { metallic 0.75 }
	}
}

#declare Robinet_1_le_noyau = object
{
cylinder { <-6, 0, 0>, <6, 0, 0>, PLOMB_DIAM+2 }
texture
	{
	pigment { color <0.5, 0.6, 0.72> }
	finish { phong_size 5.55 metallic 0.75 }
	}
}

#declare Robinet_1 = object
{
union	{
	object { Robinet_1_corps }
	object { Robinet_1_les_plaques }
	object { Robinet_1_le_noyau }
	}
}
/* ==---------------------------------------------------------== */
/* new 24 juin 2006 - avenue St Exupery				 */

#declare Coude_0 = object
{
intersection {
	torus { PLOMB_DIAM*4, PLOMB_DIAM }
	box { <0, -10, 0>, <100, 10, 100> }
	}
texture {
	pigment { color <0.9, 0.9, 0.92> }
	finish { metallic 0.75 }
	}
}
/* ==---------------------------------------------------------== */
